# used for testing all kinds of authentication cases

# create a partner with test users
#
def create_test_partner options={}
  options = {
    'client_id' => random_string(23) + '-' + random_string(8),
    'client_secret' => random_string(48),
    'num_system_accounts' => 2,

  }.merge(options)

  partner = {
    'client_id' => options['client_id'],
    'client_secret' => options['client_secret'],
  }

  partner_credentials = {
    'client_id' => partner['client_id'],
    'client_secret' => partner['client_secret'],
  }

  external_id_prefix = random_string(16) + '-'

  as_account :knerd do

    #make the partner
    partner['partner_id'] = create_partner({'name' => partner['client_id'], 'password' => partner['client_secret']})['id']

    #make system accounts
    partner['system_accounts'] = {}
    options['num_system_accounts'].times do |i|
      sys_acct = create_system_user partner['partner_id']
      sys_acct['type'] = 'system account'
      sys_acct['account_id'] = sys_acct['id']
      partner['system_accounts'][sys_acct['id']] = sys_acct
    end
  end

  #return everything
  return_data = {
    'partner' => partner,
  }
  Log.debug JSON.pretty_generate(return_data)
  return_data
end
