

def wait_for_api_to_respond timeout_secs=60, poll_interval=1
  Log.info "Waiting up to #{timeout_secs} for the platform to respond"
  #when this call returns a non-error response, we are up
  kapi.get '/v0/healthcheck',  {:additional_headers => {"accept" => "*/*", "content-type" => "text/plain"}}
  Log.info "The system has awoken, proceeding"
  true
rescue Exception => e
  timeout_secs -= poll_interval
  Log.debug "Try failed, #{timeout_secs} secs left."
  if timeout_secs < 1
    raise TimeoutError.new 'The system never came up'
  end
  sleep poll_interval
  wait_for_api_to_respond timeout_secs
end

# kapi_get is handy for making adhoc calls right off the cmd line:
# kgrift -e QA -v kapi_get "/v0/someurl?someparam=abc"
def kapi_get full_url, options={}
  kapi.get full_url, options
end
alias :bivins_get :kapi_get


def urlencode path_component
  URI.encode_www_form_component(path_component.force_encoding("UTF-8"))
end
