def get_module_iid graph, eid
  graph['nodes'].select{|n| n['temp_id'] and n['temp_id']==(graph['name']+':'+eid)}.first['id']
end

def get_full_taxon_path taxonomy, taxon_id, path=''
  taxon = taxonomy['taxons'].select{|t| t['id']==taxon_id}.first
  if taxon['parent_id']
    get_full_taxon_path(taxonomy, taxon['parent_id']) + '|' + taxon['name'] + path
  else
    taxon['name'] + path
  end
end

def construct_taxon_eid_map taxonomies
  taxons = []
  taxonomies.each do |taxonomy|
    taxonomy_name = taxonomy['name']
    taxonomy['taxons'].each do |taxon|
      taxons << {
        'iid' => taxon['id'],
        'eid' => 'tref-' + taxonomy_name + ":" + get_full_taxon_path(taxonomy, taxon['id'])
      }
    end
  end
  taxons
end

def get_taxon_eid_to_iid_map_for_graph graph_id
  #create LI, get taxonomies, and cleanup
  dummy_li = create_learning_instance 'graph_id' => graph_id
  taxonomies = get_referenced_taxonomies dummy_li['id']
  delete_learning_instance dummy_li['id']
  #construct map list
  map_list = construct_taxon_eid_map taxonomies
  #return hashmap
  map = {}
  map_list.each do |taxon|
    map[taxon['eid']] = taxon['iid']
  end
  map
end
