"""
This file is all about creating graphs and taxonomies.

This is based on the POST /v0/book_and_taxonomies endpoint that Bivins implements.
This allows for making a graph and taxonomies in a way that is not Klique.
This is mostly intended for use by Bivins localmode integration tests.

Generally most tests should not use the create_book_and_taxonomies method, instead
they should use the KnewtonGraph object that allows for making test graphs through
Klique, from spreadsheets.

"""

# SUPPORTED / CURRENT METHODS

def create_book_and_taxonomies book_and_taxonomies, partner_id=nil
  params = partner_id.nil? ? {} : { 'partner_id' => partner_id }
  kapi.post '/v0/graphs/book_and_taxonomies?' + URI.encode_www_form(params),
   book_and_taxonomies
end

def basic_book_and_taxonomies_post_object unicode=false
  file_base = unicode ? 'unicode_test_graph_definition.yml' : 'basic_test_graph_definition.yml'
  graph_definition_file = File.join(File.dirname(File.dirname(__FILE__)), 'internal_test_graphs', file_base)
  obj = YAML.load_file graph_definition_file
  obj['graph']['name'] = "#{obj['graph']['name']}_#{random_string}"
  obj
end

def create_basic_book_and_taxonomies partner_id=nil, unicode=false
  response = create_book_and_taxonomies basic_book_and_taxonomies_post_object(unicode), partner_id
  # return the graph id
  response['objectId']
end
