

def csv_to_hash csv_filename
  CSV.read(csv_filename, headers: true).map {|a| Hash[a] }
end

def csv_data_set filename, &blk
  if not File.exist? filename
    data = yield blk
    columns = data.first.keys

    csv = CSV.generate do |csv|
      csv << columns
      data.each do |row|
        csv << row.values
      end
    end
    File.open(filename, 'w') {|f| f.write csv}
  end

  csv_to_hash filename
end


# returns a flat hash that can be written right into a csv
def jmeter_partner

  partner = create_partner_with_admin

  flat_data = {
    'partner_id' => partner['partner_id'],
    'client_id' => partner['client_credentials']['client_id'],
    'client_secret' => partner['client_credentials']['client_secret'],
    'system_user_1' => partner['external_user_id'],
  }

  as_account :knerd do
    set_partner_rate_limit_multiplier partner['partner_id'], 1000.0
  end

  flat_data['basic_auth_header'] = 'Basic ' + Base64.strict_encode64(
    flat_data['client_id'] + ':' + flat_data['client_secret'])

  tokens = get_access_token 'code' => nil,
    'redirect_uri' => nil,
    'scope' => flat_data['system_user_1'],
    'grant_type' => "client_credentials",
    'client_credentials' => partner['client_credentials'],
    'external_user_id' => flat_data['system_user_1']

  # the access token isnt really useful, just the refresh token
  # flat_data['access_token'] = tokens['access_token']
  flat_data['refresh_token'] = tokens['refresh_token']

  flat_data
end
