def get_learning_instances params={}
  Log.info "Getting all learning instances, with params '#{params.keys.join(', ')}'"
  kapi.get '/v0/learning-instances?' + URI.encode_www_form(params)
end

def create_learning_instance overrides={}
  Log.info "Creating a learning instance"
  kapi.post '/v0/learning-instances', {
    'name' => random_learning_instance_name,
    'graph_id' => '123'
  }.merge(overrides)
end

# Get a learning instance.
# If you also want to the partner_id of the learning instance,
# then send this for get_opts: additional_headers: { 'X-Include-Partner-Id' => 'true' }
# You can then access the partner_id with: kapi.last_response['X-Partner-Id']
def get_learning_instance id, get_opts={}
  Log.info "Getting a learning instance: " + id
  kapi.get "/v0/learning-instances/#{id}", get_opts
end

def update_learning_instance id, overrides
  Log.info "Updating a learning instance: " + id
  kapi.put "/v0/learning-instances/#{id}", {
    #'name' => 'updated name',
  }.merge(overrides)
end

def delete_learning_instance id
  Log.info "Deleting a learning instance: " + id
  kapi.delete "/v0/learning-instances/#{id}"
end

def get_learning_instance_registrations id, params={}
  Log.info "Getting registrations for learning instance, with params '#{params.keys.join(', ')}'"
  kapi.get "/v0/learning-instances/#{id}/registrations?" + URI.encode_www_form(params)
end

# get a group recommendation (vox)
def get_group_recommendation learning_instance_id, goal_id
  Log.info "Getting a recommendation for learning instance: " + learning_instance_id + " goal: " + goal_id
  query_params= { 'goal_id' => goal_id }
  query_string = URI.encode_www_form(query_params)
  kapi.get "/v0/learning-instances/#{learning_instance_id}/recommendation?#{query_string}"
end
