# Bivins has some special looper only endpoints at /0/looper/_/
#
# These grifts can be used to test those endpoints


# looper_update_partner_display_name is the only supported way to
# update the display_name of a partner.  PUT /v0/partners/:id does not work for display_name field
#
def looper_update_partner_display_name partner_id, new_display_name
  kapi.put "/v0/looper/_/partners/#{partner_id}", {
    'display_name' => new_display_name,
  }
end

def looper_get_graph_internal_id partner_id, graph_external_id
  kapi.get "/v0/looper/_/graph_uuid_from_partner/#{partner_id}/label/#{URI.encode_www_form_component(graph_external_id)}"
end

def looper_get_graph_module_internal_id graph_id, module_external_id
  kapi.get("/v0/looper/_/module_uuid_from_graph/#{graph_id}/label/#{URI.encode_www_form_component(module_external_id)}")
end

def looper_get_graph_learning_objective_internal_id graph_id, learning_objective_eid
  kapi.get("/v0/looper/_/learning_objective_uuid_from_graph/#{graph_id}/label/#{URI.encode_www_form_component(learning_objective_eid)}")
end

def looper_get_graph_taxon_internal_id partner_id, taxon_eid, graph_id
  kapi.get("/v0/looper/_/taxon_uuid_from_partner/#{partner_id}/label/#{URI.encode_www_form_component(taxon_eid)}/graph/#{graph_id}")
end

def looper_get_indexed_graph graph_id
  kapi.get("/v0/looper/_/indexed_graphs/#{graph_id}")
end

