#NOTICE: this only lists test partners, which does not include the Knewton partner
def list_partners overrides={}
  params = {
    "test_partners" => true
  }.merge(overrides).delete_if{|k,v| v.nil?}

  Log.info "Listing all partners"
  kapi.get '/v0/partners?' + URI.encode_www_form(params), timeout: 3600
end

def list_prod_partners overrides={}
  params = {
    'test_partners' => false,
  }.merge(overrides)
  list_partners params
end

def create_partner overrides={}
  Log.info "Creating a partner"
  kapi.post '/v0/partners', {
    'name' => random_string,
    'password' => random_string,
    'is_testing' => true,
    'display_name' => 'KGriftTestingPartner_' + random_string(16),
    'rate_limit_multiplier' => 1.0,
  }.merge(overrides)
end

def update_partner id, payload
  Log.info "Updating partner: #{id}"
  kapi.put "/v0/partners/#{id}", payload
end

def get_partner id
  Log.info "Getting a partner: " + id
  kapi.get "/v0/partners/#{id}"
end

def delete_partner id
  Log.info "Deleting a partner: " + id
  kapi.delete "/v0/partners/#{id}"
end

def create_system_user id
  Log.info "Creating a system user for partner: " + id
  kapi.post "/v0/partners/#{id}/system-user", nil
end

#this will not raise an error if 409 conflict
# is returned on create call
def ensure_partner_exists overrides={}
  Log.info 'Ensuring partner exists: ' + overrides['name'].to_s
  create_partner overrides
  return true
rescue Grifter::RequestException => e
  if e.code == 409
    Log.debug "Partner already exists"
    return true
  else
    raise e
  end
end


def set_partner_rate_limit_multiplier id, multiplier
  partner = get_partner id
  update_payload = partner.merge 'rate_limit_multiplier' => multiplier
  update_payload.delete 'id'
  update_partner id, update_payload
end
