#add_new_prod_partner is used for making production partners
#it makes system users as well
#by default it makes 1 system user and 1 old-style-system-user
#you can alter either count through the options passed in
def add_new_prod_partner display_name, options={}
  if !display_name.kind_of?(String) || display_name.length < 3
    raise "You must pass in a display name that is at least 3 characters long"
  end
  options.merge!({ 'display_name' => display_name })
  set_prod_mode
  set_account :prod_knerd
  partner_data = add_new_partner options
  print "\n\nNEW PARTNER:\n#{partner_data.to_yaml}\n"
  partner_data
end

#add new test partner should be used anytime we are making
#a partner for internal testing use. Test partner are NEVER
#to be given externally as they are subject to being deleted without notice
def add_new_partner options={}

  options = {
    'num_system_users' => 1,
    'is_testing' => false,
    'filename' => 'new_partner_data.json',
    'display_name' => 'KnewtonTestingPartner_' + random_string(16),
    'rate_limit_multiplier' => 1.0,
  }.merge(options)

  new_partner_data = {
    'client_id' =>  options.fetch('client_id', random_string(32)),
    'client_secret' => options.fetch('client_secret', random_string(48)),
  }

  partner = create_partner 'name' => new_partner_data['client_id'],
    'password' => new_partner_data['client_secret'],
    'is_testing' => options['is_testing'],
    'display_name' => options['display_name'],
    'rate_limit_multiplier' => options['rate_limit_multiplier']

  new_partner_data['partner_id'] = partner['id']

  if options['num_system_users'] > 0
    new_partner_data['system_users'] = options['num_system_users'].times.map do
      new_system_user = create_system_user new_partner_data['partner_id']
      {
        'external_user_id' => new_system_user['external_user_id'],
        'account_id' => new_system_user['id'],
      }
    end
  end

  new_partner_data['created_on'] = DateTime.now.to_s
  new_partner_data['created_by'] = Etc.getlogin

  File.open(options['filename'], 'w')  do |f|
    f.write(JSON.pretty_generate(new_partner_data))
    Log.warn "Wrote the new partner data to #{options['filename']}"
  end

  return new_partner_data
end

def set_prod_mode
  grifter_configuration[:services].keys.each do |svc|
    self.send(svc).headers.delete 'knewton-test'
  end
  nil
end

def set_test_mode
  grifter_configuration[:services].keys.each do |svc|
    self.send(svc).headers['knewton-test'] = 'true'
  end
  nil
end

def get_client_id_from_partner_id partner_id
  partner_record = nil
  as_account :knerd do
    partner_record = get_partner partner_id
  end
  partner_record['name']
end

