#NODE TAG METHODS
def get_node_tags graph_id, node_id, overrides={}
  Log.info "Getting tags for graph node: #{graph_id} -> #{node_id}"
  do_as_knewton_partner overrides.delete('use_current_user') do
    kapi.get "/v0/graphs/#{graph_id}/nodes/#{node_id}/tags"
  end
end

def create_node_tag graph_id, node_id, tag_name, encode=true, overrides={}
  tag_name = URI.encode_www_form_component(tag_name) if encode
  do_as_knewton_partner overrides.delete('use_current_user') do
    Log.info "adding a tag '#{tag_name}' to graph node: #{graph_id} -> #{node_id}"
    kapi.put "/v0/graphs/#{graph_id}/nodes/#{node_id}/tags/#{tag_name}", nil
  end
end

def delete_node_tag graph_id, node_id, tag_name, encode=true, overrides={}
  tag_name = URI.encode_www_form_component(tag_name) if encode
  Log.info "deleting tag '#{tag_name}' from graph node: #{graph_id} -> #{node_id}"
  do_as_knewton_partner overrides.delete('use_current_user') do
    kapi.delete "/v0/graphs/#{graph_id}/nodes/#{node_id}/tags/#{tag_name}"
  end
end

#LEARNING INSTANCE TAG METHODS
def get_learning_instance_tags learning_instance_id
  Log.info "Getting tags for learning instance: #{learning_instance_id}"
  kapi.get "/v0/learning-instances/#{learning_instance_id}/tags"
end

def create_learning_instance_tag learning_instance_id, tag_name, encode=true
  tag_name = URI.encode_www_form_component(tag_name) if encode
  Log.info "adding a tag '#{tag_name}' to learning instance: #{learning_instance_id}"
  kapi.put "/v0/learning-instances/#{learning_instance_id}/tags/#{tag_name}", nil
end

def delete_learning_instance_tag learning_instance_id, tag_name, encode=true
  tag_name = URI.encode_www_form_component(tag_name) if encode
  Log.info "deleting tag '#{tag_name}' from learning instance: #{learning_instance_id}"
  kapi.delete "/v0/learning-instances/#{learning_instance_id}/tags/#{tag_name}"
end
