# This file is all about enabling distributed tracing with ZipKin
# When this is required, the effect is:
# Every single request gets a unique random long

# MONKEY PATCH
# use an "around alias" spell to change behavior of do_request: https://gist.github.com/nusco/534772
#

class Grifter
  class HTTPService

    alias :official_do_request :do_request

    def do_request  method, path, obj=nil, options={}
      dtrace_header = rand(2**32..2**64-1).to_s(16)
      self.headers['X-B3-TraceId'] = dtrace_header
      official_do_request  method, path, obj, options
    end
  end
end
