"""

Make a simple graph and associated set of taxonomies

This graph and taxonomy setup is used for many integration tests.

The graph/taxonomy set is owned by the knewton partner, which makes
it available for use by all partners.

For convenience, the dataset has keys for both graph ID, and the full graph.
Depending on the needs of the test, one might need only the graph ID, or one
might need to know the entire graph structure.  Both peices of info are available,
same for taxonomies.

"""


# fill up this hash with the graph and taxonomy data
data = {}

set_account :knerd
data['partner_id'] = get_partner_id_for_current_account

set_account :knerd
# make the graph, which only returns the graph ID
data['graph_id'] = create_basic_book_and_taxonomies
# get the graph
data['graph'] = get_graph data['graph_id']
# get the taxonomies
data['taxonomies'] = get_taxonomies_for_graph data['graph_id']
# for convenience, extract the taxonomy IDs into a seperate list
data['taxonomy_ids'] = data['taxonomies'].map {|tax| tax['id']}

# last line of a generator must be this hash of test data getting returned
data
