taxonomies_obj = YAML.load_file File.expand_path('../sandcastle_taxonomies.yml', __FILE__)
graph_obj = YAML.load_file File.expand_path('../sandcastle_with_taxons.yml', __FILE__)

temp_id_to_id = {}
temp_id_to_name = {}
taxonomy_ids = []
taxonomies = []

#create taxonomies and store mapping from temp_id -> ID
taxonomies_obj.each do |name, taxonomy|
    live_taxonomy = create_taxonomy overrides={'name'=>name, 'taxons'=>[]}
    taxonomy_ids << live_taxonomy['id']
    taxonomy['taxons'].each do |taxon|
        #WARNING! parent taxon must be posted before any children
        live_taxon = create_taxon taxonomy_id=live_taxonomy['id'], overrides={'name'=>taxon['name'], 'parent_id'=>temp_id_to_id[taxon['parent_id']]}
        temp_id_to_id[taxon['id']] = live_taxon['id']
        temp_id_to_name[taxon['id']] = live_taxon['name']
    end
end

taxonomy_ids.each do |taxonomy_id|
    taxonomy = get_taxonomy taxonomy_id
    taxonomies << taxonomy
end


# replace temp IDs with IDs
# make nodes taxon recommendable
#
graph_obj['nodes'].each do |node|
    live_taxon_ids = []
    if node['type'] == 'module'
      if !node.has_key?('is_taxon_recommendable')
        node['is_taxon_recommendable'] = true
      end
    end
    node['taxon_ids'].each do |taxon_id|
        live_taxon_ids << temp_id_to_id[taxon_id]
    end if node['taxon_ids']
    if live_taxon_ids.length > 0
        node['taxon_ids'] = live_taxon_ids
    else
        node.delete('taxon_ids')
    end
end

response = create_graph graph_obj

{
    'graph_id' => response['id'],
    'mapping' => response,
    'taxonomy_ids' => taxonomy_ids,
    'taxonomies' => taxonomies,
    'taxon_temp_id_to_id' => temp_id_to_id,
    'taxon_temp_id_to_name' => temp_id_to_name
}
