wait_for_api_to_respond

test_knerd_credentials = knerd_accounts['knerd']

#make sure we can login, and stop immediately if we can not
begin
  set_account test_knerd_credentials
rescue Exception => e
  Kernel.abort "ERROR: Failed to login using knewton partner that should just be there:\n#{e.to_s}"
end

accounts = {
  'system_user_default' => {'client'=>'test_partner_default'},
  'system_user_a' => {'client'=>'test_partner_a'},
  'system_user_b' => {'client'=>'test_partner_b'},
  'user_default' => {'client'=>'test_partner_default'},
  'user_a' => {'client'=>'test_partner_a'},
  'user_b' => {'client'=>'test_partner_b'},
}
partners = {
  'test_partner_default' => {},
  'test_partner_a' => {},
  'test_partner_b' => {},
}

#add test partners
partners.each_pair do |client_label, client_data|
  password = random_string

  # make the partner with a high rate_limit_multiplier to avoid any
  # token based rate limit issues  with these test partners
  # rate limits are tested with different partners
  credentials = create_partner 'password' => password,
    'display_name' => "#{client_label} #{random_string(8)}",
    'rate_limit_multiplier' => 100.0

  full_credentials = {
    'client_id' => credentials['name'],
    'client_secret' => password,
    'partner_id' => credentials['id'],
  }
  client_data.merge! full_credentials
end

#add system accounts
accounts.select{|k,v| k.start_with? 'system_user'}.each_pair do |account_label, account_data|
  partner = partners[accounts[account_label]['client']]
  account_data['client_credentials'] = {
    'client_id' => partner['client_id'],
    'client_secret' => partner['client_secret'],
  }
  account_data['external_user_id'] = (create_system_user partner['partner_id'])['external_user_id']
end

#add regular user accounts
accounts.select{|k,v| k.start_with? 'user'}.each_pair do |account_label, account_data|
  partner = partners[accounts[account_label]['client']]
  system_user = accounts.select{|k,v| v['client']==account_data['client'] and
                                      k.start_with?('system_user')}.map{|k,v| v}.first
  #create users as a partner system user
  as_account system_user['external_user_id'], system_user['client_credentials'] do
    account_data['client_credentials'] = {
      'client_id' => partner['client_id'],
      'client_secret' => partner['client_secret'],
    }
    account_data['external_user_id'] = (create_account)['external_user_id']
  end
end

unauthenticate

#return all accounts and partners
{
  'accounts' => accounts,
  'partners' => partners,
}
